"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _traverse = _interopRequireDefault(require("@babel/traverse"));

var _parser = require("@babel/parser");

var _path = _interopRequireDefault(require("path"));

var _nextStaticContextGetstaticpropsTransform = require("../babel/next-static-context-getstaticprops-transform");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const getStaticContextLoader = function (source) {
  console.log(this.data);
  const callback = this.async();
  const assetInfo = {
    sourceFilename: 'getStaticContext.js'
  };
  const ast = (0, _parser.parse)(source);
  let containsGetStaticContext = false;
  (0, _traverse.default)(ast, {
    ExportNamedDeclaration(exportNamedPath) {
      const declarationPath = exportNamedPath.get('declaration');

      if (declarationPath.isFunctionDeclaration()) {
        const declaration = declarationPath.node;

        if ((0, _nextStaticContextGetstaticpropsTransform.isGetStaticProps)(declaration)) {
          containsGetStaticContext = true;
          return;
        }
      }

      if (declarationPath.isVariableDeclaration()) {
        const declaration = declarationPath.node;
        const functionDeclarator = declaration.declarations.find(declarator => exportNamedPath.isFunctionExpression(declarator.init) || exportNamedPath.isArrowFunctionExpression(declarator.init));

        if (functionDeclarator && (0, _nextStaticContextGetstaticpropsTransform.isGetStaticProps)(functionDeclarator)) {
          containsGetStaticContext = true;
        }
      }
    }

  }, undefined, {
    done: false
  });
  console.log(containsGetStaticContext);

  if (containsGetStaticContext) {
    var _this$data;

    this.data.paths = (((_this$data = this.data) === null || _this$data === void 0 ? void 0 : _this$data.paths) ?? []).concat([this.resourcePath]);
    const getStaticContextSource = `
  ${this.data.paths.map(importPath => {
      const basename = _path.default.basename(importPath).split('.')[0];

      const keyIdentifier = `${basename}Key`;
      const getterIdentifier = `${basename}Getter`;
      return `import { staticContextKey as ${keyIdentifier}, getStaticContext as ${getterIdentifier} } from '${importPath}';`;
    }).join('\n')}
  
  const contextGetters = {
    ${this.data.paths.map(importPath => {
      const basename = _path.default.basename(importPath).split('.')[0];

      const keyIdentifier = `${basename}Key`;
      const getterIdentifier = `${basename}Getter`;
      return `[${keyIdentifier}]: ${getterIdentifier},`;
    })}
  };
  
  export async function getStaticContext(slug) {
    return Object.fromEntries(
      await Promise.all(
        Object.entries(contextGetters).map(async ([key, getter]) => [key, await getter(slug)])
      )
    );
  }
    `;
    this.resolve(this.rootContext, 'getStaticContext.js', (resolveErr, resolvedPath) => {
      if (resolveErr) callback(resolveErr);
      this.emitFile(resolvedPath, getStaticContextSource, undefined, assetInfo);
      callback(null, source);
    });
  } else {
    callback(null, source);
  }
};

var _default = getStaticContextLoader;
exports.default = _default;